\begin{algorithm}
\caption{EpTO Dissemination Component Modification}
\begin{algorithmic}[1]
  \State $\delta \gets ...$
  \State $TTL \gets ...$
  \item[]

  \Function{EpTO-broadcast}{event}
    \State $event.ts \gets \Call{GetClock}{ }$
    \State $event.pts \gets \Call{GetPClock}{ }$
    \State $event.sourceId \gets p.id$
    \State $\Call{Netcode-Broadcast}{event}$
  \EndFunction
  \item[]

  \UponReceive{EpTO-Event}{event} 
    \If{$event.pts + \delta \cdot TTL > \Call{GetPClock}{ }$}
      \State $\Call{OrderEvent}{event}$
    \EndIf
    \State $\Call{UpdateClock}{event.ts}$
  \EndUponReceive
  \item[]

\end{algorithmic}
\end{algorithm}

\begin{algorithm}
\caption{EpTO Ordering Component}
\begin{algorithmic}[1]
  \State $recv \gets \varnothing$ \Comment{Received}
  \State $dlv \gets \varnothing$ \Comment{Delivered}
  \State $lastdlvTs \gets 0$ \Comment{Time of last delivered event}
  \item[]

  \Function{IsDeliverable}{event}
    \State \Return $event.pts + \delta \cdot TTL < \Call{GetPClock}{ }$
  \EndFunction
  \item[]

  \Function{OrderEvent}{event}
    \If{$event.id \notin dlv \land event.ts \geq lastdlvTs $}
      \State $recv \gets recv + (event.id, event)$
    \EndIf
    \item[]

    \State $minQueuedTs \gets \infty $
    \State $dlvEvts \gets \varnothing$ \Comment{Deliverable Events}
    \ForAll{$event \in recv$}
      \If {$\Call{IsDeliverable}{event}$}
        \State $dlvEvts \gets dlvEvts \cup event$
      \ElsIf{$ minQueuedTs > event.ts $}
        \State $minQueuedTs \gets event.ts$
      \EndIf
    \EndFor
    \item[]

    \ForAll{$event \in dlvEvts$}
      \If{$event.ts > minQueuedTs$}
        \State $dlvEvts \gets dlvEvts \setminus event$
      \Else
        \State $recv \gets recv - (event.id, event)$
      \EndIf
    \EndFor
    \item[]

    \ForAll{$event \in dlvEvts$ \textbf{sorted by} $(ts, srcId)$}
      \State $dlv \gets dlv \cup event$
      \State $lastdlvdTs \gets event.ts$
      \State $\Call{Deliver}{event}$
    \EndFor
  \EndFunction

\end{algorithmic}
\end{algorithm}


